var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { AbstractStreamingSyncImplementation } from '@journeyapps/powersync-sdk-common';
export class WebStreamingSyncImplementation extends AbstractStreamingSyncImplementation {
    constructor(options, options2) {
        super(options);
        this.options2 = options2;
    }
    obtainLock(lockOptions) {
        return navigator.locks.request(`streaming-sync-${lockOptions.type}-${this.options2.workerIdentifier}`, () => __awaiter(this, void 0, void 0, function* () {
            try {
                yield lockOptions.callback();
            }
            catch (ex) {
                console.error('caught exception in lock context', ex);
                throw ex;
            }
        }));
    }
}
//# sourceMappingURL=WebStreamingSyncImplementation.js.map